#!/bin/bash

# (C) Copyright 2015 Superwrt.com
#  All Rights Reserved

help()
{
	echo "SuperWRT Firmware Package Maker"
	echo " usage: $1 <kernel> <rootfs> <output>"
}

mkimg() #1: kernel 2: rootfs 3: output
{
	local kl klb
	kl=$(($((16#$(hexdump -v -s 12 -n 4 -e '/1 "%02x"' $1)))+64))
	klb=$((65536-($kl&65535)))
	[ $klb -eq 65536 ] && klb=0
	dd if=$1 bs=$kl count=1 of=$3 >/dev/null 2>&1
	dd if=/dev/zero bs=1 seek=$kl count=$klb of=$3 >/dev/null 2>&1
	cat $2 >> $3
}

ck_squashfs() #1: rootfs
{
	local magic=$(hexdump -n 4 -e '/1 "%02x"' $1)
	if [ "$magic" = "68737173" ]; then
		return 0
	fi
	return 1
}

ck_kernel() #1: kernel
{
	local magic=$(hexdump -n 4 -e '/1 "%02x"' $1)
	if [ "$magic" = "27051956" ]; then
		return 0
	fi
	return 1
}

ck_squashfs $2
if [ $? = 1 ]; then
	echo Wrong rootfs! Need squashfs.
	exit -1
fi
ck_kernel $1
if [ $? = 1 ]; then 
	echo Wrong kernel! Need uboot image header.
	exit -1
fi
mkimg $1 $2 $3
echo Output image to $3
